// _advanced expert advisor template.mq4
// Copyright  2009, TradingSystemForex.Com
// http://www.tradingsystemforex.com/

#property copyright "Copyright  2009, TradingSystemForex.Com"
#property link "http://www.tradingsystemforex.com/"

extern string comment="EA";              // comment to display in the order
extern int magic=1234;                   // magic number required if you use different settings on a same pair, same timeframe

extern string moneymanagement="Money Management";

extern double lots=0.1;                  // lots size
extern bool lotsoptimized=false;         // enable risk management
extern double risk=1;                    // risk in percentage of the account
//extern bool martingale=false;          // enable the martingale
//extern double multiplier=2.0;          // multiplier used for the martingale
extern double minlot=0.01;               // minimum lot allowed by the expert
extern double maxlot=10;                 // maximum lot allowed by the expert
extern double lotdigits=2;               // 1 for minilot, 2 for microlot
//extern bool basketpercent=false;       // enable the basket percent
//extern double profit=10;               // close all orders if a profit of 10 percents has been reached
//extern double loss=30;                 // close all orders if a loss of 30 percents has been reached

extern string ordersmanagement="Order Management";

extern bool oppositeclose=true;          // close the orders on an opposite signal
extern bool reversesignals=false;        // reverse the signals, long if short, short if long
extern int maxtrades=1;                // maximum trades allowed by the traders
extern int tradesperbar=1;               // maximum trades per bar allowed by the expert
extern bool hidesl=false;                // hide stop loss
extern bool hidetp=false;                // hide take profit
extern int stoploss=0;                   // stop loss
extern int takeprofit=0;                 // take profit
extern int trailingstart=0;              // profit in pips required to enable the trailing stop
extern int trailingstop=0;               // trailing stop
extern int trailingstep=1;               // margin allowed to the market to enable the trailing stop
extern int breakevengain=0;              // gain in pips required to enable the break even
extern int breakeven=0;                  // break even
int expiration=0;                        // expiration in minutes for pending orders
int slippage=0;                          // maximum difference in pips between signal and order
double maxspread=100;                    // maximum spread allowed by the expert

extern string entrylogics="Entry Logics";

extern bool waitforpullback=true;
extern int pullbackmargin=5;
extern bool autosl=true;
extern int slmargin=5;
extern bool closeonsignal=true;
extern int Length=10;
extern int ATRperiod=5;
extern double Kv=2.5;
extern bool usefilter=true;
extern int TimeFrame=60;
extern int Lengthtf=10;
extern int ATRperiodtf=5;
extern double Kvtf=2.5;
extern int shift=1;                      // bar in the past to take in consideration for the signal
/*
extern string timefilter="Time Filter";

extern int gmtshift=2;                   // gmt offset of the broker
extern bool filter=false;                // enable time filter
extern int start=7;                      // start to trade after this hour
extern int end=21;                       // stop to trade after this hour
extern bool tradesunday=true;            // trade on sunday
extern bool fridayfilter=false;          // enable special time filter on friday
extern int fridayend=24;                 // stop to trade after this hour
*/
datetime t0,t1,lastbuyopentime,lastsellopentime;
double lastbuyopenprice,lastsellopenprice,lastbuyprofit,lastsellprofit,lastprofit;
double lotsfactor=1,initiallotsfactor=1,ilots,lastbuylot,lastselllot;
double ask,bid,cb,sl,tp,min,max;
int i,bc=-1,tpb,tps,cnt,istart,iend,total,ticket;
int lastorder,buyorderprofit,sellorderprofit,history;

double pt,mt;
int dg;

int init(){
   t0=Time[0];
   t1=Time[0];
   dg=Digits;
   if(dg==3 || dg==5){pt=Point*10;mt=10;}else{pt=Point;mt=1;}
/*
   //|---------martingale initialization

   int tempfactor;
   total=OrdersTotal();
   if(tempfactor==0 && total>0){
      for(i=0;i<total;i++){
         if(OrderSelect(i,SELECT_BY_POS)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
               tempfactor=NormalizeDouble(OrderLots()/lots,1+(MarketInfo(Symbol(),MODE_MINLOT)==0.01));
               break;
            }
         }
      }
   }
   int histotal=OrdersHistoryTotal();
   if(tempfactor==0&&histotal>0){
      for(cnt=0;cnt<histotal;cnt++){
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
               tempfactor=NormalizeDouble(OrderLots()/lots,1+(MarketInfo(Symbol(),MODE_MINLOT)==0.01));
               break;
            }
         }
      }
   }
   if(tempfactor>0)
   lotsfactor=tempfactor;
*/
   return(0);
}

int start(){
/*
   GlobalVariableSet("vGrafBalance",AccountBalance());
   GlobalVariableSet("vGrafEquity",AccountEquity());
*/
   RefreshRates();
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);

   if(breakevengain>0)movebreakeven(breakevengain,breakeven);
   if(trailingstop>0)movetrailingstop(trailingstart,trailingstop);
   //if(basketpercent)closebasketpercent(profit,loss);
/*
   lastbuylot=0;
   lastselllot=0;
   lastorder=0;

   history=OrdersHistoryTotal();
   if(history>0){
      for(i=0;i<history;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            lastprofit=OrderProfit();
            if(OrderType()==OP_BUY){
               lastbuyprofit=OrderProfit();
               lastbuylot=OrderLots();
               lastorder=1;
            }
            if(OrderType()==OP_SELL){
               lastsellprofit=OrderProfit();
               lastselllot=OrderLots();
               lastorder=2;
            }
         }
      }
   }

   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderCloseTime()==0){
            if(OrderType()==OP_BUY){
               lastbuyopentime=OrderOpenTime();
               lastbuyopenprice=OrderOpenPrice();
               buyorderprofit=OrderProfit();
            }
            if(OrderType()==OP_SELL){
               lastsellopentime=OrderOpenTime();
               lastsellopenprice=OrderOpenPrice();
               sellorderprofit=OrderProfit();
            }
         }
      }
   }
*/

   if(tradesperbar==1 && (((TimeCurrent()-lastbuyopentime)<Period()) || ((TimeCurrent()-lastsellopentime)<Period()))){tpb=1;tps=1;}
   if(bc!=Bars){tpb=0;tps=0;bc=Bars;}
   
   double atu0=iCustom(Symbol(),0,"ATRStops_v1.1",Length,ATRperiod,Kv,0,0);
   double atu=iCustom(Symbol(),0,"ATRStops_v1.1",Length,ATRperiod,Kv,0,shift);
   double atua=iCustom(Symbol(),0,"ATRStops_v1.1",Length,ATRperiod,Kv,0,shift+1);
   
   double atd0=iCustom(Symbol(),0,"ATRStops_v1.1",Length,ATRperiod,Kv,1,0);
   double atd=iCustom(Symbol(),0,"ATRStops_v1.1",Length,ATRperiod,Kv,1,shift);
   double atda=iCustom(Symbol(),0,"ATRStops_v1.1",Length,ATRperiod,Kv,1,shift+1);
   
   double atutf=iCustom(Symbol(),0,"ATRstops_v1.1_MTF",TimeFrame,Lengthtf,ATRperiodtf,Kvtf,0,shift);
   double atdtf=iCustom(Symbol(),0,"ATRstops_v1.1_MTF",TimeFrame,Lengthtf,ATRperiodtf,Kvtf,1,shift);
   
   int atrsignal=0;
   if(((waitforpullback==false && atu>0 && atu!=EMPTY_VALUE && atda>0 && atda!=EMPTY_VALUE) || (waitforpullback && atu>0 && atu!=EMPTY_VALUE && ask<atu0+pullbackmargin*pt && ask>atu0 && atu0>0 && atu0!=EMPTY_VALUE))
   && (usefilter==false || (usefilter && atutf>0 && atutf!=EMPTY_VALUE)))atrsignal=1;
   
   if(((waitforpullback==false && atd>0 && atd!=EMPTY_VALUE && atua>0 && atua!=EMPTY_VALUE) || (waitforpullback && atd>0 && atd!=EMPTY_VALUE && bid>atd0-pullbackmargin*pt && bid<atd0 && atd0>0 && atd0!=EMPTY_VALUE))
   && (usefilter==false || (usefilter && atdtf>0 && atdtf!=EMPTY_VALUE)))atrsignal=2;

   bool buy=false;bool sell=false;
   if(atrsignal==1){if(reversesignals)sell=true;else buy=true;}
   if(atrsignal==2){if(reversesignals)buy=true;else sell=true;}

   //Comment("\nhau = "+DoubleToStr(hau,4),"\nhad = "+DoubleToStr(had,4));

   if((oppositeclose && sell) || (autosl && ask<(atu-slmargin*pt)) || (closeonsignal && atd>0 && atd!=EMPTY_VALUE && atua>0 && atua!=EMPTY_VALUE))closebuy();
   if((oppositeclose && buy) || (autosl && bid>(atd+slmargin*pt)) || (closeonsignal && atu>0 && atu!=EMPTY_VALUE && atda>0 && atda!=EMPTY_VALUE))closesell();

   if(hidesl){
      for(i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(stoploss>0 && bid<(OrderOpenPrice()-stoploss*pt))closebuy();
         if(stoploss>0 && ask>(OrderOpenPrice()+stoploss*pt))closesell();
      }
   }
   if(hidetp){
      for(i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(takeprofit>0 && bid>(OrderOpenPrice()+takeprofit*pt))closebuy();
         if(takeprofit>0 && ask<(OrderOpenPrice()-takeprofit*pt))closesell();
      }
   }
/*
   istart=start+(gmtshift);if(istart>23)istart=istart-24;
   iend=end+(gmtshift);if(iend>23)iend=iend-24;

   if((tradesunday==false && DayOfWeek()==0) || (filter && DayOfWeek()>0 && ((istart<=iend && !(Hour()>=(istart)&&Hour()<=(iend)))
   || (istart>iend && !((Hour()>=(istart)&&Hour()<=23) || (Hour()>=0&&Hour()<=(iend)))))) || (fridayfilter&&DayOfWeek()==5 && !(Hour()<(fridayend+(gmtshift))))){return(0);}
*/
   if((ask-bid)>maxspread*pt)return(0);
   if((count(OP_BUY)+count(OP_SELL))>=maxtrades)return(0);

   if(lotsoptimized /*&& (martingale==false || (martingale && lastprofit>=0))*/)lots=NormalizeDouble((AccountBalance()/1000)*minlot*risk,lotdigits);

   int expire=0;
   if(expiration>0)expire=TimeCurrent()+(expiration*60)-5;

   if(buy && tpb<tradesperbar){
      /*if(martingale)ilots=NormalizeDouble(lots*martingalefactor(),2);else*/ ilots=lots;
      ticket=open(OP_BUY,ilots,ask,stoploss,takeprofit,expire,Blue);
      if(ticket<=0){/*Print("Error Occured : "+errordescription(GetLastError()));*/}else tpb++;
   }
   if(sell && tps<tradesperbar){
      /*if(martingale)ilots=NormalizeDouble(lots*martingalefactor(),2);else*/ ilots=lots;
      ticket=open(OP_SELL,ilots,bid,stoploss,takeprofit,expire,Red);
      if(ticket<=0){/*Print("Error Occured : "+errordescription(GetLastError()));*/}else tps++;
   }
   return(0);
}

//|---------open

int open(int type,double lots,double price,int stoploss,int takeprofit,int expire,color clr){
   //RefreshRates
   //ask=MarketInfo(Symbol(),MODE_ASK);
   //bid=MarketInfo(Symbol(),MODE_BID);
   int i=0;int tries=100;int error=0;int ticket=0;
   if(ilots<minlot)ilots=minlot;
   if(ilots>maxlot)ilots=maxlot;
   if(type==OP_BUY || type==OP_BUYSTOP || type==OP_BUYLIMIT){
      if(hidesl==false && stoploss>0){sl=price-stoploss*pt;}else{sl=0;}
      if(hidetp==false && takeprofit>0){tp=price+takeprofit*pt;}else{tp=0;}
   }
   if(type==OP_SELL || type==OP_SELLSTOP || type==OP_SELLLIMIT){
      if(hidesl==false && stoploss>0){sl=price+stoploss*pt;}else{sl=0;}
      if(hidetp==false && takeprofit>0){tp=price-takeprofit*pt;}else{tp=0;}
   }
   for(i=0;i<tries;i++){
      ticket=OrderSend(Symbol(),type,lots,price,slippage*mt,sl,tp,comment+". Magic: "+DoubleToStr(magic,0),magic,expire,clr);
      error=GetLastError();
      if(error==0/* NO_ERROR */)break;
      if(!(error==4/* SERVER_BUSY */ || error==137/* BROKER_BUSY */ || error==146/* TRADE_CONTEXT_BUSY */ || error==136/* OFF_QUOTES */))break;
      Sleep(1000);
   }
   //if(type==OP_BUY && ticket>0){Print("Order opened : "+Symbol()+" Buy @ "+ask+" SL @ "+sl+" TP @"+tp+" ticket ="+ticket);}
   //if(type==OP_SELL && ticket>0){Print("Order opened : "+Symbol()+" Sell @ "+bid+" SL @ "+sl+" TP @"+tp+" ticket ="+ticket);}
   return(ticket);
}

//|---------counter

int count(int type){
   cnt=0;
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderType()==type && OrderMagicNumber()==magic)cnt++;
      }
      return(cnt);
   }
}

//|---------close

void closebuy(){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY){
            OrderClose(OrderTicket(),OrderLots(),bid,slippage*mt);
         }
      }
   }
}

void closesell(){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL){
            OrderClose(OrderTicket(),OrderLots(),ask,slippage*mt);
         }
      }
   }
}
/*
//|---------delete

void deletepending(int type){
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==type){
          OrderDelete(OrderTicket());
        }   
      }
   }
}
*/
//|---------breakeven

void movebreakeven(int breakevengain,int breakeven){
   RefreshRates();
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble((bid-OrderOpenPrice()),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if((NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),dg)<NormalizeDouble(breakeven*pt,dg))||OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+breakeven*pt,dg),OrderTakeProfit(),0,Blue);
                     return(0);
                  }
               }
            }
            else{
               if(NormalizeDouble((OrderOpenPrice()-ask),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if((NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),dg)<NormalizeDouble(breakeven*pt,dg))||OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-breakeven*pt,dg),OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}

//|---------trailingstop

void movetrailingstop(int trailingstart,int trailingstop){
   RefreshRates();
   ask=MarketInfo(Symbol(),MODE_ASK);
   bid=MarketInfo(Symbol(),MODE_BID);
   total=OrdersTotal();
   if(total>0){
      for(i=0;i<total;i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(ask,dg)>NormalizeDouble(OrderOpenPrice()+trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)<NormalizeDouble(bid-(trailingstop+trailingstep)*pt,dg))||(OrderStopLoss()==0)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(bid-trailingstop*pt,dg),OrderTakeProfit(),0,Blue);
                  return(0);
               }
            }
            else{
               if(NormalizeDouble(bid,dg)<NormalizeDouble(OrderOpenPrice()-trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)>(NormalizeDouble(ask+(trailingstop+trailingstep)*pt,dg)))||(OrderStopLoss()==0)){                 
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(ask+trailingstop*pt,dg),OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
      }
   }
}
/*
//|---------basket

void closebasketpercent(double profit,double loss){
   double ipf=profit*(0.01*AccountBalance());
   double ilo=loss*(0.01*AccountBalance());
   cb=AccountEquity()-AccountBalance();
   if(cb>=ipf||cb<=(ilo*(-1))){
      closebuy();
      closesell();
      deletepending(OP_BUYSTOP);
      deletepending(OP_SELLSTOP);
      deletepending(OP_BUYLIMIT);
      deletepending(OP_SELLLIMIT);
      return(0);
   }
}
*//*
//|---------martingale

int martingalefactor(){
   history=OrdersHistoryTotal();
   if(history>0){
      for(i=0;i<history;i++){
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
               if(OrderProfit()<0){
                  lotsfactor=lotsfactor*multiplier;
                  return(lotsfactor);
               }
               else{
                  lotsfactor=initiallotsfactor;
                  if(lotsfactor<=0){
                     lotsfactor=1;
                  }
                  return(lotsfactor);
               }
            }
         }
      }
   }
   return(lotsfactor);
}
*//*
//|---------error

string errordescription(int code){
   string error;
   switch(code){
      case 0:
      case 1:error="no error";break;
      case 2:error="common error";break;
      case 3:error="invalid trade parameters";break;
      case 4:error="trade server is busy";break;
      case 5:error="old version of the client terminal";break;
      case 6:error="no connection with trade server";break;
      case 7:error="not enough rights";break;
      case 8:error="too frequent requests";break;
      case 9:error="malfunctional trade operation";break;
      case 64:error="account disabled";break;
      case 65:error="invalid account";break;
      case 128:error="trade timeout";break;
      case 129:error="invalid price";break;
      case 130:error="invalid stops";break;
      case 131:error="invalid trade volume";break;
      case 132:error="market is closed";break;
      case 133:error="trade is disabled";break;
      case 134:error="not enough money";break;
      case 135:error="price changed";break;
      case 136:error="off quotes";break;
      case 137:error="broker is busy";break;
      case 138:error="requote";break;
      case 139:error="order is locked";break;
      case 140:error="long positions only allowed";break;
      case 141:error="too many requests";break;
      case 145:error="modification denied because order too close to market";break;
      case 146:error="trade context is busy";break;
      case 4000:error="no error";break;
      case 4001:error="wrong function pointer";break;
      case 4002:error="array index is out of range";break;
      case 4003:error="no memory for function call stack";break;
      case 4004:error="recursive stack overflow";break;
      case 4005:error="not enough stack for parameter";break;
      case 4006:error="no memory for parameter string";break;
      case 4007:error="no memory for temp string";break;
      case 4008:error="not initialized string";break;
      case 4009:error="not initialized string in array";break;
      case 4010:error="no memory for array\' string";break;
      case 4011:error="too long string";break;
      case 4012:error="remainder from zero divide";break;
      case 4013:error="zero divide";break;
      case 4014:error="unknown command";break;
      case 4015:error="wrong jump (never generated error)";break;
      case 4016:error="not initialized array";break;
      case 4017:error="dll calls are not allowed";break;
      case 4018:error="cannot load library";break;
      case 4019:error="cannot call function";break;
      case 4020:error="expert function calls are not allowed";break;
      case 4021:error="not enough memory for temp string returned from function";break;
      case 4022:error="system is busy (never generated error)";break;
      case 4050:error="invalid function parameters count";break;
      case 4051:error="invalid function parameter value";break;
      case 4052:error="string function internal error";break;
      case 4053:error="some array error";break;
      case 4054:error="incorrect series array using";break;
      case 4055:error="custom indicator error";break;
      case 4056:error="arrays are incompatible";break;
      case 4057:error="global variables processing error";break;
      case 4058:error="global variable not found";break;
      case 4059:error="function is not allowed in testing mode";break;
      case 4060:error="function is not confirmed";break;
      case 4061:error="send mail error";break;
      case 4062:error="string parameter expected";break;
      case 4063:error="integer parameter expected";break;
      case 4064:error="double parameter expected";break;
      case 4065:error="array as parameter expected";break;
      case 4066:error="requested history data in update state";break;
      case 4099:error="end of file";break;
      case 4100:error="some file error";break;
      case 4101:error="wrong file name";break;
      case 4102:error="too many opened files";break;
      case 4103:error="cannot open file";break;
      case 4104:error="incompatible access to a file";break;
      case 4105:error="no order selected";break;
      case 4106:error="unknown symbol";break;
      case 4107:error="invalid price parameter for trade function";break;
      case 4108:error="invalid ticket";break;
      case 4109:error="trade is not allowed";break;
      case 4110:error="longs are not allowed";break;
      case 4111:error="shorts are not allowed";break;
      case 4200:error="object is already exist";break;
      case 4201:error="unknown object property";break;
      case 4202:error="object is not exist";break;
      case 4203:error="unknown object type";break;
      case 4204:error="no object name";break;
      case 4205:error="object coordinates error";break;
      case 4206:error="no specified subwindow";break;
      default:error="unknown error";
   }
   return(error);
}
*/